# 2020-101

## Introduction

This project will be created under the guidelines provided by the Research Project module offered in 4th Year by the Faculty of Computing. The title of the project is "Student and Lecturer Performance Enhancement System". This Research Project comes under the domain of Artifical Intelligence and Machine Learning along with the support of Computer Vision.

## Main Objective

Main Objectives that will be targetted in this Research Project will be listed as follows.


* Tracking student attendance using facial detection and facial recognition and notify and getting opinion from the students who are absent and students who are leaving the lecture in the during a specified time period (Attendance Register).
* Monitoring student behavior within the classroom during lecture periods to identify potential problem areas in retaining student attention and adapting the lecturing styles to suit the student needs (Monitoring Student Behavior). 
* Summarize the converted text and present as a document and identify the important points of the lecture to display them highlighted (Lecture Summarizing).
* Monitoring lecturers’ behavior by analyzing the teaching style in a lecture hall during the lecture hours (Monitor Lecturer Performance).  


## Main Research Questions

This Research Project will be conducted to find answers for the following 4 research questions.


* “What is the optimum way of tracking student attendance in a much efficient way and how does the lecturer analyze reasons for student absenteeism?” (Q1). 
* “Does a correlation exist between lecturing style and student behavior in the classroom and how can Computer Vision and Artificial Intelligence be incorporated in determining this relationship?” (Q2). 
* “How to summarize the lecture content to enable students to pay more attention to the lecture and reduce time spend for taking notes?” (Q3). 
* “How to evaluate lecture performance by tracking their behavior during a lecture and analyzing the quality of the lecture content which is delivered by the lecturer?” (Q4).  


## Individual Research Questions

The main research questions came up for the project were based on each individual component that will be implemented through the course of the project. Hence, the individual research questions could be listed down as follows.

### Attendance Register

*What is the optimum way of tracking student attendance in a much efficient way and how does the lecturer analyze reasons for student absenteeism?*

### Monitoring Student Behavior

*Does a correlation exist between lecturing style and student behavior in the classroom and how can Computer Vision and Artificial Intelligence be incorporated in determining this relationship?.* 

### Lecture Summarizing

*How to summarize the lecture content to enable students to pay more attention to the lecture and reduce time spend for taking notes?*

### Monitoring Lecturer Performance

*How to evaluate lecture performance by tracking their behavior during a lecture and analyzing the quality of the lecture content which is delivered by the lecturer?”*

## Individual Objectives

The main objectives of the research project could be further split into individual objectives which elaborates purpose of the project in much detail.

### Attendance Register

* Tracking student attendance using facial detection and facial recognition.
* Notify and getting opinion from the students who are absent and students who are leaving the lecture in the during a specified time period.
* Setting up student data and respective course data in an adaptive manner.
* Provide an overview for the lecturer regarding student attendance through a dashboard and predicting future attendance.

### Monitoring Student Behavior

* Monitoring student behavior within the classroom during lecture periods to identify potential problem areas in retaining student attention and adapting the lecturing styles to suit the student needs.
* Identifying the concentration level, emotion expressions and general behavior of students within 2-hour lecture duration using facial recognition, emotion recognition and motion detection employing computer vision technologies.
* Determining the dependency between student behavior and the lecturer behavior by analyzing overall behavior status of students and lecturer for a given time frame during the lecture.

### Lecture Summarizing

* Understand lecturer’s voice and filter the lecturer’s voice by removing background noises and silent pauses
* Convert the noise-filtered audio into text
* Summarize the converted text and present as a document.
* Identify the important points of the lecture to display them highlighted.
* Display important notices mentioned in the lecture.

### Monitoring Lecturer Performance

* Monitoring lecturers’ behavior by analyzing the teaching style in a lecture hall during the lecture hours.
* Identifying the lectures emotional state when the lecture is conducting.
* Generating an end-semester feedback of the lecturer giving a summary of their performance. 


## System Architecture

![System Acrhitecture of SLPES](SLPES_System.jpg)

As mentioned in the given figure, this system will mainly consist of a mobile and web application. When the students and the lecturer enter the classroom, their behavior will be monitored by two separate video-cameras and a microphone. The collected data will transmit to the server through raspberry-pi and stores the gathered data in the MongoDB cloud database service. While the video camera tracks both facial expression and body movements, the microphone will record the lecture for further analysis. The student attendance will register by capturing facial identity using deep learning and computer vision mechanisms. Students will be monitored by capturing their facial and body movements by Computer Vision and Deep Learning algorithms. The lecturer audio and video details will be gathered and stored for analyzing as such lecture summarizing and monitoring lecturer performance using machine learning, deep learning, and computer vision technologies. While the students have access to the mobile application, the lecturers and the higher management have the authority to manage the web-application. Frontend components will communicate with the backend using Django REST API.


## Module Description

### Branch structure

The following list contains the respective branch names for each individual

*  **db_and_monitoring** - IT17097284
*  **monitoring_student_behavior_IT17138000** - IT17138000
*  **IT17100908** - IT17100908

Note that the **QA_RELEASE** branch is the merged branch of all the working components. The **master** contains only the common folder strcuture of the project.

### Folder structure

This folder structure adheres to the general project structure of a django web project. The following list describes the folders and files in use throughout the entire project.

* **AttendanceApp** - comprises the work of *Attendance Register* component.
* **FirstApp** - contains the implementations of *Monitoring Student Behavior* component.
* **LectureSummarizingApp** - constitutes the workings of the *Lecture Summarization* component.
* **MonitorLecturerApp** - comprises the implementations of *Monitoring Lecturer Performance* component.
* **integrated_slpes** - this contains the general settings and url configurations of the entire project.  
* **manage.py** - this file is required to run the project (done by the comman *python manage.py runserver*)
* **requirements.txt** - contains the list of dependencies required to run the project.

### Application strcuture

As mentioned above, the folders such as *AttendanceApp* and *FirstApp* are the applications reserved for each individual module. The following list will elaborate the common folders and files in an application folder.

* **logic** - this folder contains the basic logic implementation for the application (implementations of deep learning models, processing etc...).
* **migrations** - comprises of the database migration files (*migration* in django means a way of propogating the changes made to your model, to the database schema). This is a folder generated by the django framework.
* **templates** - this folder contains the html files (frontend) of the relevant application. However, the templates should be added inside another folder, with the same name as of your application.
* **admin.py** - registering the models to the django admin site.
* **api.py** - contains the RESTful API for the application.
* **models.py** - all the database models are created within this file.
* **serializers.py** - django provides a library to serialize the database models to facilitate the communication through REST API. The serialized class for each model is created here.
* **tests.py** - test case implementations
* **urls.py** - contains the specific url mappings for an application.
* **views.py** - implements the frontend logic for each template file.

## Installation

To run this project, you will need to follow the given steps.

1.  clone the repository to a desired location in your machine.
2.  to download the classifiers, visit [here](https://www.google.com)

